﻿using Kivii.Samples.Entities;
using Kivii.Web;
using Kivii.Linq;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Samples.Transforms
{
    public class RfidBoundCreate : RestfulExecution<RfidBound>
    {
        public RfidBound Item { get; set; }

        public override object OnExecution(IRequest req, IResponse res)
        {
            Item.ThrowIfNull("请传入Item!");
            (Item.Tid.IsNullOrEmpty()).ThrowIfTrue("请传入Tid!");
            (Item.Epc.IsNullOrEmpty()).ThrowIfTrue("请传入Epc!");

            var rtns = new RestfulCreateResponse<RfidBound>();
            rtns.Results = new List<RfidBound>();

            var conn = KiviiContext.GetOpenedDbConnection<RfidBound>();
            var exist = conn.Single<RfidBound>(o => o.Tid == Item.Tid);
            if (exist != null)
            {
                exist.Epc = Item.Epc;
                exist.AddOnlyProperties(o => o.Epc);
                conn.UpdateOnly(exist);
                exist.RemoveAllOnlyProperties();
                rtns.Results.Add(exist);
            }
            else
            {
                conn.Insert(Item);
                Item.RemoveAllOnlyProperties();
                rtns.Results.Add(Item);
            }
            return rtns;
        }
    }

    public class RfidBoundQuery : RestfulQuery<RfidBound>
    {
    }

    public class RfidBoundRead : RestfulRead<RfidBound>
    {
    }

    public class RfidBoundDelete : RestfulDelete<RfidBound>
    {
    }
}
